package de.kif.frontend.repository

import de.kif.common.Message
import de.kif.common.Repository
import de.kif.common.RepositoryType
import de.kif.common.Serialization
import de.kif.common.model.Room
import de.kif.frontend.MessageHandler
import de.westermann.kobserve.event.EventHandler
import kotlinx.serialization.DynamicObjectParser
import kotlinx.serialization.list
import kotlinx.serialization.serializer

object AnnouncementRepository {

    private val prefix = js("prefix")

    val onUpdate = EventHandler<Unit>()

    private val parser = DynamicObjectParser()

    suspend fun getAnnouncement(): String {
        val json = repositoryGet("$prefix/api/announcement") ?: return ""
        return parser.parse(json, String.serializer())
    }

    suspend fun setAnnouncement(value: String){
        return repositoryPost("$prefix/api/announcement", Serialization.stringify(String.serializer(), value))
            ?: throw IllegalStateException("Cannot set announcement!")
    }

    val handler = object : MessageHandler(RepositoryType.ROOM) {

        override fun onCreate(id: Long) {}

        override fun onUpdate(id: Long) = onUpdate.emit(Unit)

        override fun onDelete(id: Long) {}
    }
}
